<template>
  <l-map
      ref="map"
      v-model:zoom="zoom"
      v-model:center="center"
      :options="{attributionControl: false}">
    <l-tile-layer
      url="http://tile.osm.ch/osm-swiss-style/{z}/{x}/{y}.png"
      layer-type="base"
      name="Swiss Style OSM"
    ></l-tile-layer>
    <l-marker :lat-lng="markerPos">
      <l-popup> <!--having it open automatically
      does not seem to be possible with this version of vue-leaflet-->
        OST Campus RJ
      </l-popup>
    </l-marker>
    <l-control-attribution
      position="bottomright"
      :prefix="attribution"
    ></l-control-attribution>
  </l-map>
</template>

<script>

import {LControlAttribution,
  LMap,
  LMarker,
  LPopup,
  LTileLayer
} from "@vue-leaflet/vue-leaflet";

export default {
  name: "MapComponent",
  components: {
    LMap,
    LTileLayer,
    LMarker,
    LPopup,
    LControlAttribution
  },
  data() {
    return {
      zoom: 18,
      geojson: null,
      markerPos: [47.22331, 8.81752],
      center: [47.22331, 8.81752],
      attribution: "Data &copy " +
          "<a href='http://openstreetmap.org/copyright'>OpenStreetMap</a> " +
          "contributors <a href='https://opendatacommons.org/licenses/odbl/'>ODbL</a> | " +
          "Map by <a href='https://sosm.ch/'>SOSM</a> | " +
          "<a id='problem-attribution' " +
          "href='http://www.openstreetmap.org/fixthemap?" +
          "lat=47.41330&lon=8.65639&zoom=18'>Report a problem</a>",
    };
  },
  watch: {
    zoom() {
      this.updateProblemLink();
    },
    center() {
      this.updateProblemLink();
    }
  },
  methods: {
    updateProblemLink() {
      this.$el.querySelector("#problem-attribution")
          .href = "http://www.openstreetmap.org/fixthemap?" +
          `lat=${this.center.lat}&lon=${this.center.lng}` +
          `&zoom=${this.zoom}`;
    }
  },
}
</script>

<style scoped>

</style>